program ExCrypt;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  TokenID in '..\ExCommon\TokenID.pas',
  GlobalDef in '..\ExCommon\GlobalDef.pas',
  rijndael in '..\TeleToken\rijndael.pas',
  TeleToken in '..\TeleToken\TeleToken.pas',
  ZeroMem in '..\ExCommon\ZeroMem.pas';

var
  n   : cardinal;
  i   : byte;
  stmp: string;
  tab,
  tmp : array [0..15] of byte;
{$I '..\ExCommon\MainDef.pas'}

{$UNSAFECODE ON}
procedure Main; unsafe;
begin

  ZeroMemory(PassTbl,16*PASS_NO);
  n:=0;
  while (n<PASS_NO) do
    begin
      stmp:='Pass' + IntToStr(n);
      StrCopy(@PassTbl[n*16], stmp);
      Inc(n);
    end;

{$I '..\ExCommon\Prolog.pas'}

  // zainicjowanie OutKey
  OutKey:=(GetTickCount() and $FFFFFF00) or $F00;

  // szyfrowanie i deszyfrowanie Tokenem
  Write('Szyfrowanie TeleTokenem:');

  n:=0;
  while (n<TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE]) do
    begin
      ZeroMemory(OutDataA,16);
      ZeroMemory(OutDataB,16);
      ZeroMemory(InDataA,16);
      ZeroMemory(InDataB,16);

      Inc(OutKey);                              				// zwikszenie licznika kluczy

      OutDataB[TVTTD_CMD]:=TVTTC_ENCRYPT;       				// rozkaz szyfrowania TeleTokenem
      OutDataB[TVTTD_PARAM1]:=n;                				// numer hasa

      TVTT_Rand(tab);

      i:=0;                                     				// wypenienie bufora danymi do zapisania
      while (i<16) do
        begin
          OutDataA[i]:=tab[i];
          Inc(i);
        end;

      TVTT_CalcAuth(OutDataA,OutDataB);        					// policzenie bloku kontrolnego
      TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T); 	// zaszyfrowanie pierwszego bloku danych
      TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T);  	// zaszyfrowanie drugiego bloku danych
      Status:=TVTT_Talk(TokenH,10,OutKey,@OutDataA,@OutDataB,@InKey,@InDataA,@InDataB);
      TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);    	// rozszyfrowanie pierwszego bloku danych
      TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);    	// rozszyfrowanie drugiego bloku danych

      if (Status<>0) then
        begin
          Write(#9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $FF,2));
          Break;
        end;

      if (TVTT_CheckAuth(InDataA,InDataB)<>0) then
        begin
          Write(#9 + 'Blad bloku kontrolnego!');
          Break;
        end;

      if (InDataB[TVTTD_STATUS]<>0) then
        begin
          WriteLn(#9 + IntToHex(InDataB[TVTTD_STATUS], 2));
          Break;
        end;

      if (InKey=0) then
        begin
          WriteLn(#9 + 'Wiadomo nie zaszyfrowana!');				// sprawdzenie czy wiadomo zaszyfrowana
          Break;
        end;

      // sprawdzenie poprawnoci szyfrowania

      for i := 0 to 15 do tmp[i] := PassTbl[n*16+i];
      rijndaelEncrypt(tmp,tab);

      i:=0;
      while (i<16) do
        begin
          if (tab[i]<>InDataA[i]) then Break;
          Inc(i);
        end;

      if (i<16) then
        begin
          WriteLn(#9 + #9 + 'Crypt - Blad porownania');
          Break;
        end;

      // deszyfrowanie bloku

      ZeroMemory(OutDataA,16);
      ZeroMemory(OutDataB,16);
      ZeroMemory(InDataA,16);
      ZeroMemory(InDataB,16);

      Inc(OutKey);                            					// zwikszenie licznika kluczy

      OutDataB[TVTTD_CMD]:=TVTTC_DECRYPT;     					// rozkaz deszyfrowania TeleTokenem
      OutDataB[TVTTD_PARAM1]:=n;              					// numer hasa

      TVTT_Rand(tab);

      i:=0;                                  					// wypenienie bufora danymi do zapisania
      while (i<16) do
        begin
          OutDataA[i]:=tab[i];
          Inc(i);
        end;

      TVTT_CalcAuth(OutDataA,OutDataB);      					// policzenie bloku kontrolnego
      TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T);  	// zaszyfrowanie pierwszego bloku danych
      TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T);  	// zaszyfrowanie drugiego bloku danych
      Status:=TVTT_Talk(TokenH,10,OutKey,@OutDataA,@OutDataB,@InKey,@InDataA,@InDataB);
      TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);    	// rozszyfrowanie pierwszego bloku danych
      TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);    	// rozszyfrowanie drugiego bloku danych

      if (Status<>0) then
        begin
          Write(#9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $FF,2));
          Break;
        end;

      if (TVTT_CheckAuth(InDataA,InDataB)<>0) then
        begin
          Write(#9 + 'Blad bloku kontrolnego!');
          Break;
        end;

      if (InDataB[TVTTD_STATUS]<>0) then
        begin
          WriteLn(#9 + #9 +IntToHex(InDataB[TVTTD_STATUS], 2));
          Break;
        end;

      if (InKey=0) then
        begin
          WriteLn(#9 + 'Wiadomo nie zaszyfrowana!');      			// sprawdzenie czy wiadomo zaszyfrowana
          Break;
        end;

      // sprawdzenie poprawnoci deszyfrowania

      for i := 0 to 15 do tmp[i] := PassTbl[n*16+i];
      rijndaelDecrypt(tmp,tab);

      i:=0;
      while (i<16) do
        begin
          if (tab[i]<>InDataA[i]) then Break;
          Inc(i);
        end;

      if (i<16) then
        begin
          WriteLn(#9 + #9 + 'Decrypt - Blad porownania');
          Break;
        end;

      inc(n);
    end;

  if (n=TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE]) then WriteLn(#9 + 'OK');

{$I '..\ExCommon\Epilog.pas'}
end;
{$UNSAFECODE OFF}

begin
  Main;
end.
