program ExNvMemDecryptWrite;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  TokenID in '..\ExCommon\TokenID.pas',
  GlobalDef in '..\ExCommon\GlobalDef.pas',
  rijndael in '..\TeleToken\rijndael.pas',
  TeleToken in '..\TeleToken\TeleToken.pas',
  ZeroMem in '..\ExCommon\ZeroMem.pas';

{$UNSAFECODE ON}

var
{$I '..\ExCommon\MainDef.pas'}

procedure Main; unsafe;
label fail;
var i, n: Byte;
    stmp: String;
    iv: array [0..15] of Byte;             // init wektor do szyfrowania w trybie CBC
    data: array of array [0..15] of Byte;  // tablica na dane
begin
  ZeroMemory(PassTbl, 16*PASS_NO);
  n := 0;
  while (n < PASS_NO) do
  begin
    stmp :='Pass' + IntToStr(n);
    StrCopy(@PassTbl[n*16], stmp);
    n := n + 1;
  end;

  {$I '..\ExCommon\Prolog.pas'}

	{ Przykad obrazujcy zapis zaszyfrowanych danych do TeleTokenu. Zademonstrowane jest
	   uycie trybu CBC do zaszyfrowania (przygotowania) danych do zapisu do TeleTokenu.
	   Z drugiej strony TeleToken podczas operacji zapisu rozszyfrowywuje dane rwnie
	   w trybie CBC, z uyciem wbudowanej pamici ulotnej (1 sektora). }

  // zainicjowanie OutKey
  OutKey:=(GetTickCount() and $FFFFFF00) or $F00;

	// wylosowanie init vector-a
	TVTT_Rand(iv);

  SetLength(data, TokenInfoTbl[TVTTTI_NV_MEM_SIZE]);

	// przygotowanie danych do zapisania
	for n := 0 to TokenInfoTbl[TVTTTI_NV_MEM_SIZE] - 1 do
    for i := 0 to 15 do data[n][i] := Byte(n*16+i);

	// szyfrowanie metoda CBC

	// XOR 1 bloku danych z init vector-em
	for i := 0 to 15 do data[0][i] := data[0][i] xor iv[i];

	// petla szyfrujca
  n := 0;
	while True do
  begin
    rijndaelEncrypt(PassTbl, data[n]);

    n := n + 1;
    if n = TokenInfoTbl[TVTTTI_NV_MEM_SIZE] then break;

    // XOR bloku n z zaszyfrowanym blokiem n-1
    for i := 0 to 15 do data[n][i] := data[n][i] xor data[n-1][i];
  end;

	{ Przygotowanie sektora pamici ulotnej do deszyfrowania w trybie CBC. Do sektora "0"
	   wgrywany jest "init vector", z ktrym TeleToken automatycznie wykona operacj XOR
	   po uprzednim zdeszyfrowaniu pierwszego bloku danych. Po tej operacji pierwszy
	   zaszyfrowany blok danych trafi do wybranego (tu "0") sektora RAM, na poczet przyszego
	   wykorzystania do operacji XOR. Tym sposobem do wykonania zapisu z deszyfrowaniem
	   w trybie CBC naley tylko raz, przed rozpoczciem deszyfrowania, wgra blok pocztkowy
	   ("init vector") do wybranego sektora pamici RAM. Numer tego sektora podawany jest
	   jako argument w rozkazie "deszyfruj i zapisz". Podanie numeru spoza zakresu (0-7)
	   spowoduje uycie deszyfrowania w trybie ECB (kady blok osobno). }

	// zapis IV do pamici ulotnej

	Write('Zapis pam. ul. TeleTokenu: ');

	ZeroMemory(OutDataA, 16);
	ZeroMemory(OutDataB, 16);
	ZeroMemory(InDataA, 16);
	ZeroMemory(InDataB, 16);

	OutKey := OutKey + 1;                                                       // zwikszenie licznika kluczy

	OutDataB[TVTTD_CMD] := TVTTC_VMEM_WRITE;                                    // rozkaz zapisu pamici ulotnej TeleTokenu
	OutDataB[TVTTD_PARAM1] := 0;                                                // numer sektora do zapisania

	for n := 0 to 15 do OutDataA[n] := iv[n];                                   // wypenienie bufora danymi do zapisania

	TVTT_CalcAuth(OutDataA, OutDataB);                                          // policzenie bloku kontrolnego
	TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T);     // zaszyfrowanie pierwszego bloku danych
	TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T);     // zaszyfrowanie drugiego bloku danych
	Status := TVTT_Talk(TokenH, 10, OutKey, @OutDataA, @OutDataB, @InKey, @InDataA, @InDataB);
	TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC);       // rozszyfrowanie pierwszego bloku danych
	TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC);       // rozszyfrowanie drugiego bloku danych

  if (Status <> 0) then
  begin
    Write(#9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $ff, 2));
    goto fail;
  end;

  if (TVTT_CheckAuth(InDataA, InDataB) <> 0) then
  begin
    Write(#9 + 'Blad bloku kontrolnego!');
    goto fail;
  end;

  if (InDataB[TVTTD_STATUS] <> 0) then
  begin
    WriteLn(#9 + IntToHex(InDataB[TVTTD_STATUS], 2));
    goto fail;
  end;

  if (InKey = 0) then
  begin
    WriteLn(#9 + 'Wiadomosc nie zaszyfrowana!');    				                  // sprawdzenie czy wiadomo zaszyfrowana
    goto fail;
  end;

	WriteLn(#9'OK');

  // zapis pamici TeleTokenu
  Write('Zapis pam. nieul. TeleTokenu:');

  n := 0;
  while (n < TokenInfoTbl[TVTTTI_NV_MEM_SIZE]) do
  begin
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);

    OutKey := OutKey + 1;                      					                      // zwikszenie licznika kluczy

    OutDataB[TVTTD_CMD] := TVTTC_NVMEM_DECRYPT_WRITE;                         // rozkaz zapisu pamici Tokenu z uprzednim rozszyfrowaniem bloku danych
    OutDataB[TVTTD_PARAM1] := n;                                              // numer sektora do zapisania
    OutDataB[TVTTD_PARAM2] := 0;                                              // numer hasa do uycia przy deszyfrowaniu
    OutDataB[TVTTD_PARAM3] := 0;                                              // numer sektora pamici ulotnej do uycia przy deszyfrowaniu trybem CBC

    // wypenienie bufora danymi do zapisania
    for i := 0 to 15 do OutDataA[i] := data[n][i];

    TVTT_CalcAuth(OutDataA, OutDataB);        						                    // policzenie bloku kontrolnego
    TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T);  	// zaszyfrowanie pierwszego bloku danych
    TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T);  	// zaszyfrowanie drugiego bloku danych
    Status:=TVTT_Talk(TokenH, 2, OutKey, @OutDataA, @OutDataB, @InKey, @InDataA, @InDataB);
    TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC); 	  // rozszyfrowanie pierwszego bloku danych
    TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC);    	// rozszyfrowanie drugiego bloku danych

    if (Status <> 0) then
    begin
      Write(#9 + IntToHex((Status shr 8), 2) + ':'  + IntToHex(Status and $ff, 2));
      Break;
    end;

    if (TVTT_CheckAuth(InDataA,InDataB) <> 0) then
    begin
      Write(#9 + 'Blad bloku kontrolnego!');
      Break;
    end;

    if (InDataB[TVTTD_STATUS] <> 0) then
    begin
      WriteLn(#9 + IntToHex(InDataB[TVTTD_STATUS], 2));
      Break;
    end;

    if (InKey = 0) then
    begin
      WriteLn(#9 + 'Wiadomosc nie zaszyfrowana!');    				                // sprawdzenie czy wiadomo zaszyfrowana
      Break;
    end;

    n := n + 1;
  end;

  if (n = TokenInfoTbl[TVTTTI_NV_MEM_SIZE]) then WriteLn(#9'OK');

fail:
{$I '..\ExCommon\Epilog.pas'}
end;
{$UNSAFECODE OFF}

begin
  Main;
end.

