unit TeleToken;

interface
uses
  Windows,
  rijndael,
  ZeroMem;

type
  PByte = ^Byte;

{$UNSAFECODE ON}
  // funkcje biblioteki 'TeleToken.dll'
  function TVTT_GetVersion(var Ver, SubVer, APIVer : cardinal): cardinal; stdcall; external 'TeleToken.dll';
  function TVTT_FindToken(TokenH: Pointer; TimeOut, OwnerID: cardinal; OwnerMsk, Skip: byte;
                  FeatureTblSize: Pointer; FeatureTbl: Pointer): cardinal; unsafe; stdcall; external 'TeleToken.dll';
  function TVTT_FreeToken(TokenH: cardinal): cardinal; stdcall; external 'TeleToken.dll';
  function TVTT_StartSession(TokenH, TimeOut: cardinal): cardinal; stdcall; external 'TeleToken.dll';
  function TVTT_Talk(TokenH, TimeOut, OutKey: cardinal; OutDataA, OutDataB,
            InKey, InDataA, InDataB: Pointer): cardinal; unsafe; stdcall; external 'TeleToken.dll';
  function TVTT_EndSession(TokenH:cardinal): cardinal; stdcall; external 'TeleToken.dll';
  function TVTT_GetSerialNr(TokenH: Cardinal; TimeOut: Cardinal; SerialNr: Pointer): cardinal; unsafe; stdcall; external 'TeleToken.dll';
  // funkcje moduu 'TeleToken.pas'
  procedure TVTT_CalcAuth(var DataA, DataB: array of byte);
  function TVTT_CheckAuth(var DataA, DataB: array of  byte):byte;
  procedure TVTT_CalcSessionKey(var SessionKey, PassPC, RandPC , PassT, RandT: array of Byte);
  procedure TVTT_CryptBlock(var Block : array of byte; Key : cardinal;
              Pass: array of byte; BlockNr, Direction : byte);
  procedure TVTT_RandInit(var Init : array of byte);
  procedure TVTT_RandGetInit(var Init : array of byte);
  procedure TVTT_Randomize(SrcNr : byte; Data : cardinal);
  procedure TVTT_Rand(var Rand: array of byte; Offset: Cardinal = 0);
{$UNSAFECODE OFF}

const
//------------------------------------------------------------------------------
  // Stae biblioteki
  TVTT_BLOCK_A                    = 0;      // staa definujca numer bloku danych przy szyfrowaniu pierwszego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe
  TVTT_BLOCK_B                    = 1;      // staa definujca numer bloku danych przy szyfrowaniu drugiego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe
  TVTT_PC2T                       = 0;      // staa definujca kierunek przesania wiadomoci z PC do Tokenu - na potrzeby funkcji generujcej hasa tymczasowe
  TVTT_T2PC                       = 1;      // staa definujca kierunek przesania wiadomoci z Tokenu do PC - na potrzeby funkcji generujcej hasa tymczasowe
  TVTT_RAND_INIT_TBL_SIZE         = (16*4); // staa definiujca rozmiar tablicy inicjujcej generator liczb pseudolosowych


//------------------------------------------------------------------------------
  // Kody bdw zwracane przez DLL
  TVTTS_OK                       = 0;       // wszystko OK
  TVTTS_INVALID_HANDLE           = $100;    // niepoprany uchwyt na Token
  TVTTS_NULL_PTR                 = $200;    // adres na parametr jest wyzerowany
  TVTTS_BAD_PARAM                = $300;    // podany parametr jest nie poprawny
  TVTTS_TOO_MANY_OPEN_TOKENS     = $400;    // za duo otwartych TeleTokenw
  TVTTS_USB_DOES_NOT_EXIST       = $500;    // nie znaleziono portu USB
  TVTTS_TOKEN_NOT_FOUND          = $600;    // Token nie znaleziony
  TVTTS_TIME_OUT                 = $700;    // przekroczenie czasu trwania operacji
  TVTTS_SEQ_EXPIRED              = $800;    // sesja nie zostaa otwarta lub wygasa
  TVTTS_ALREADY_OPENED           = $900;    // sesja jest ju otwarta
  TVTTS_UNKNOWN_ERROR            = $1000;   // nieznany typ bdu - zwracany gdy nie da sie jednoznacznie zakwalifikowa bdu np.: operacja systemowa zwrcia nieoczekiwany kod bdu
//------------------------------------------------------------------------------
  // definicja pl tablicy opisujcej moliwoci Tokenu
  TVTTTI_ID                         = 0;
  TVTTTI_NV_MEM_SIZE                = 1;
  TVTTTI_RAM_SIZE                   = 2;
  TVTTTI_PROTECT_MEM_SIZE           = 3;
  TVTTTI_PASS_TABLE_SIZE            = 4;
  TVTTTI_BITS_PER_PASS              = 5;
  TVTTTI_COUNTERS                   = 6;
  TVTTTI_BITS_PER_COUNTER           = 7;
  TVTTTI_EXT_VERSION                = 8;

  TVTTTI_TABLE_SIZE                 = 9;

  // definicja standardowych pl w drugim bloku danych
  TVTTD_CMD                         = 0;
  TVTTD_STATUS                      = 0;
  TVTTD_PARAM1                      = 1;
  TVTTD_PARAM2                      = 2;
  TVTTD_PARAM3                      = 3;
  TVTTD_AUTH                        = 4;

  // kody rozkazw TeleTokenu
  TVTTC_OPEN                        = $01;
  TVTTC_CLOSE                       = $02;
  TVTTC_FORMAT                      = $0F;

  TVTTC_NVMEM_READ                  = $11;
  TVTTC_NVMEM_WRITE                 = $12;
  TVTTC_NVMEM_WRITE_PROTECT         = $13;
  TVTTC_NVMEM_PROTECT               = $14;
  TVTTC_NVMEM_DECRYPT_WRITE         = $15;

  TVTTC_VMEM_READ                   = $91;
  TVTTC_VMEM_WRITE                  = $92;

  TVTTC_ENCRYPT                     = $21;
  TVTTC_DECRYPT                     = $22;

  TVTTC_CNT_READ                    = $31;
  TVTTC_CNT_INC_READ                = $32;
  TVTTC_CNT_DEC_READ                = $33;
  TVTTC_CNT_WRITE                   = $34;
  TVTTC_CNT_INC_ENCRYPT_READ        = $35;
  TVTTC_CNT_WRITE_CONFIG            = $36;
  TVTTC_CNT_SET_CONFIG              = $37;
  TVTTC_CNT_CLR_CONFIG              = $38;
  TVTTC_CNT_DECRYPT_WRITE           = $39;

  TVTTC_PASS_WRITE                  = $41;
  TVTTC_PASS_WRITE_CONFIG           = $42;
  TVTTC_PASS_SET_CONFIG             = $43;
  TVTTC_PASS_CLR_CONFIG             = $44;

  // podrozkazy do rozkazu TVTTC_CNT_DECRYPT_WRITE
  TVTTCS_CNT_WRITE                  = $00;
  TVTTCS_CNT_INC                    = $01;
  TVTTCS_CNT_DEC                    = $02;

  // kody statusu TeleTokenu
  TVTTS_NO_OPEN                     = $11;
  TVTTS_EXPIRED                     = $12;
  TVTTS_DAMAGED                     = $13;

  TVTTS_NOT_SUPPORTED               = $21;
  TVTTS_OUT_OF_RANGE                = $22;
  TVTTS_PROTECTION_NOT_SUPPORTED    = $23;

  TVTTS_PASS_NOT_PERMITTED          = $31;
  TVTTS_NOT_PERMITTED               = $32;
  TVTTS_ACCESS_EXPIRED              = $33;

  // bity konfiguracji hase
  TVTTPC0_TOKEN                     = $01;
  TVTTPC0_PASS_WRITE                = $02;
  TVTTPC0_PASS_CONFIG               = $04;
  TVTTPC0_MEM_READ                  = $08;
  TVTTPC0_MEM_WRITE                 = $10;
  TVTTPC0_ENCRYPT                   = $20;
  TVTTPC0_DECRYPT                   = $40;
  TVTTPC0_DECRYPT_WRITE             = $80;

  TVTTPC1_CNT_READ                  = $01;
  TVTTPC1_CNT_WRITE                 = $02;
  TVTTPC1_CNT_CONFIG                = $04;
  TVTTPC1_ENCRYPT_PASS              = $08;
  TVTTPC1_DECRYPT_PASS              = $10;
  TVTTPC1_CNT_ENCRYPT_PASS          = $20;
  TVTTPC1_WRITE_ENABLED             = $40;
  TVTTPC1_CONFIG_ENABLED            = $80;

  //bity konfiguracji licznikw

  TVTTCC0_WRITE                     = $01;
  TVTTCC0_READ                      = $02;
  TVTTCC0_INC_READ                  = $04;
  TVTTCC0_DEC_READ                  = $08;
  TVTTCC0_INC_ENCRYPT_READ          = $10;
  TVTTCC0_STOP_AT_ZERO              = $20;
  TVTTCC0_NVMEM_READ                = $40;
  TVTTCC0_NVMEM_WRITE               = $80;

  TVTTCC1_PASS                      = $01;
  TVTTCC1_NVMEM_DECRYPT_WRITE       = $02;
  TVTTCC1_CONFIG_ENABLED            = $80;

var
  RandKeyA    : array [0..15] of byte;        // generator liczb pseudolosowych - pierwsza poowa klucza generatora
  RandKeyB    : array [0..15] of byte;        // generator liczb pseudolosowych - pierwsza poowa klucza generatora
  RandCnt     : array [0..15] of byte;        // generator liczb pseudolosowych - licznik wywoa generatora liczb pseudolosowych
  RandRand    : array [0..(16*32)-1] of byte; // generator liczb pseudolosowych - bufor na kolejk zdarze losowych
  RandRandNr  : array [0..255] of byte;       // generator liczb pseudolosowych - licznik kolejkowania zdarze losowych
	RandRandCnt : array [0..31] of cardinal;
implementation
{*****************************************************************************
Funkcja liczy blok kontrolny wiadomoci i umieszcza go w drugim bloku danych
We:
Adresy na oba bloki danych
Wy:
wyliczony blok autoryzacji zapisany do drugiego bloku danych
*****************************************************************************}
procedure TVTT_CalcAuth(var DataA, DataB: array of byte);
var
  SrcPtr  : integer;
  DstPtr  : integer;
begin

  // wypenienie bloku kontrolnego wartoci 0xFF
  DstPtr:=0;
  while (DstPtr<12) do
    begin
      DataB[TVTTD_AUTH+DstPtr]:=$FF;
      inc(DstPtr);
    end;

  // doczenie do obszaru kontrolnego, danych pierwszego bloku danych
  DstPtr:=0;

  SrcPtr:=0;
  while(SrcPtr<16) do
    begin
      DataB[TVTTD_AUTH+DstPtr]:=(DataB[TVTTD_AUTH+DstPtr] xor DataA[SrcPtr]) and $ff;
      DstPtr:=(DstPtr+1) mod 12;
      inc(SrcPtr);
    end;

  // doczenie do obszaru kontrolnego, danych drugiego bloku danych
  SrcPtr:=0;
  while(SrcPtr<TVTTD_AUTH) do
    begin
      DataB[TVTTD_AUTH+DstPtr]:=(DataB[TVTTD_AUTH+DstPtr] xor DataB[SrcPtr]) and $ff;
      DstPtr:=(DstPtr+1) mod 12;
      inc(SrcPtr);
    end;
end;


{*****************************************************************************
Funkcja sprawdza poprawno bloku kontrolnego wiadomoci
We:
Adresy na oba bloki danych
Wy:
0 - blok kontrolny poprawny lub !0 - blok kontrolny nie poprawny

*****************************************************************************}
function TVTT_CheckAuth(var DataA, DataB: array of  byte):byte;
var
  SrcPtr  : integer;
  DstPtr  : integer;
begin

  // "usunicie" z obszaru kontrolnego, danych pierwszego bloku danych
  DstPtr:=0;

  SrcPtr:=0;
  while(SrcPtr<16) do
    begin
      DataB[TVTTD_AUTH+DstPtr]:=DataB[TVTTD_AUTH+DstPtr] xor DataA[SrcPtr];
      DstPtr:=(DstPtr+1) mod 12;
      inc(SrcPtr);
    end;

  // "usunicie" z obszaru kontrolnego, danych drugiego bloku danych
  SrcPtr:=0;
  while(SrcPtr<TVTTD_AUTH) do
    begin
      DataB[TVTTD_AUTH+DstPtr]:=DataB[TVTTD_AUTH+DstPtr] xor DataB[SrcPtr];
      DstPtr:=(DstPtr+1) mod 12;
      inc(SrcPtr);
    end;;

  // sprawdzenie czy blok kontrolny wypeniony wartoci 0xFF
  DstPtr:=0;
  while (DstPtr<12) do
    begin
      if (DataB[TVTTD_AUTH+DstPtr]<>$FF) then  // bd w bloku kontrolnym
        begin
          result:=1;
          exit;
        end;
      inc(DstPtr);
    end;

  result:=0;											                                              // blok kontrolny poprawny
end;

{*****************************************************************************
Funkcja wylicza klucz sesji
We:
Adres na wyliczony klucz sesji (adres na tablic docelow)
Haso PC
Tablica losowa PC
Haso Tokenu
Tablica losowa Tokenu
Wy:
wyliczony klucz sesji wpisany do podanej tablicy

*****************************************************************************}
procedure TVTT_CalcSessionKey(var SessionKey, PassPC, RandPC , PassT, RandT: array of Byte);
var
  i       : integer;
  Data    : array [0..15] of byte;
begin
  i:=0;												                                                  // skopiowanie tablicy losowej PC do bufora
  while(i<16) do
    begin
      Data[i]:=RandPC[i];
      inc(i);
    end;

  rijndaelEncrypt(PassT, Data);                                                 // zaszyfrowanie tablicy losowej PC hasem Tokenu

  i:=0;												                                                  // przepisanie uzyskanej czsci klucza do tablicy klucza sesji
  while(i<16) do
    begin
      SessionKey[i]:=Data[i];
      inc(i);
    end;

  i:=0;												                                                  // skopiowanie tablicy losowej Tokenu do bufora
  while(i<16) do
    begin
      Data[i]:=RandT[i];
      inc(i);
    end;

  rijndaelEncrypt(PassPC,Data);										                              // zaszyfrowanie tablicy losowej Tokenu hasem PC

  i:=0;													                                                // poczenie pierwszej czsci klucza sesji z uzyskan drug czsci klucza sesji
  while(i<16) do
    begin
      SessionKey[i] := (SessionKey[i] xor Data[i]) and $ff;
      inc(i);
    end;

  i:=0;												                                                  // wyczyszczenie bufora pomocniczego
  while(i<16) do
    begin
      Data[i]:=0;
      inc(i);
    end;
end;

{*****************************************************************************
Funkcja rozszyfrowuje lub szyfruje podany blok danych
We:
Adres na blok do zaszyfrowania
Klucza szyfrowania wiadomoci
Haso sesji
Numer bloku danych (0-blok pierwszy, 1-blok drugi)
Kierunek przesyania wiadomoci (0 - PC->Token, 1 - Token->PC)
Wy:
zaszyfrowany blok danych

*****************************************************************************}
procedure TVTT_CryptBlock(var Block : array of byte; Key : cardinal;
          Pass: array of byte; BlockNr, Direction : byte);
var
  i         : integer;
  HashTable : array [0..15] of byte;
begin

  if (Key=0) then exit;									                                        // Key=0 jest znacznikiem wiadomoci nieszyfrowanej -> wyjcie

  i:=0;												                                                  // wyczyszczenie tablicy mieszajcej
  while(i<16) do
    begin
      HashTable[i]:=0;
      inc(i);
    end;

  HashTable[0]:=Key and $FF;                                                    // przygotowanie do generowania klucza tymczasowego - wpisanie klucza szyfrowania wiadomoci do tablicy wynikowej
  Key:=Key shr 8;
  HashTable[1]:=Key and $FF;
  Key:=Key shr 8;
  HashTable[2]:=Key and $FF;

  HashTable[3]:=BlockNr and $FF;                                                // przygotowanie do gewnerowania klucza tymczasowego - doczenie numeru bloku danych
  HashTable[4]:=Direction and $FF;                                              // przygotowanie do gewnerowania klucza tymczasowego - doczenie znacznika kierunku przesyu wiadomoci
  rijndaelEncrypt(Pass,HashTable);				                                      // wygenerowanie hasa tymczasowego

  i:=0;												                                                  // rozszyfrowanie lub zaszyfrowanie bloku oraz wyczyszczenie tablicy mieszajcej
  while(i<16) do
    begin
      Block[i]:=(Block[i] xor HashTable[i]) and $ff;
      HashTable[i]:=0;
      inc(i);
    end;
end;

{*****************************************************************************
Funkcja dodaje zdarzenia losowe do generatora liczb pseudolosowych
We:
	Numer rda zdarze losowych
	Warto zdarzenia

*****************************************************************************}

procedure TVTT_Randomize(SrcNr : byte; Data : cardinal);
var
  Buff        : array [0..15] of byte;
  n           : byte;
  RandOffset  : cardinal;
  TmpTbl      : array [0..15] of Byte;

begin

  // zwikszenie licznika danych w kolejce
  if (RandRandCnt[RandRandNr[SrcNr and $FF] and 31]<>$FFFFFFFF) then
    inc(RandRandCnt[RandRandNr[SrcNr and $FF] and 31]);

  // wyliczenie offsetu na kolejke i zwikszenie licznika kolejek
  RandOffset:=(RandRandNr[SrcNr and $FF] and 31)*16;
  RandRandNr[SrcNr]:=(RandRandNr[SrcNr]+1)and 31;

  // wyczyszczenie bufora i wpisanie do niego danych o zdarzeniu
  n:=0;
  while (n<16) do
    begin
      Buff[n]:=0;
      inc(n);
    end;

  Buff[0]:=SrcNr;
  Buff[1]:=byte(Data);
  Data:=Data shr 8;
  Buff[2]:=byte(Data);
  Data:=Data shr 8;
  Buff[3]:=byte(Data);
  Data:=Data shr 8;
  Buff[4]:=byte(Data);

  // pomieszanie danych o zdarzeniu z danymi z kolejki
  for n := 0 to 15 do TmpTbl[n] := RandRand[RandOffset+n];
  rijndaelEncrypt(TmpTbl,Buff);

  // wpisanie nowych danych do kolejki i zamazanie zawartoci bufora
  n:=0;
  while (n<16) do
    begin
      RandRand[n+RandOffset]:=Buff[n];
      Buff[n]:=0;
      inc(n);
    end;
end;

{*****************************************************************************
Funkcja generuje 16-bajtowy blok pseudolosowy
We:
	Adres na blok do wypenienia wartociami losowymi
Wy:
	blok danych pseudolosowych

*****************************************************************************}

procedure TVTT_Rand(var Rand: array of byte; Offset: Cardinal = 0);
var
  n : cardinal;
  i : byte;
  NewKeyA : array [0..15] of byte;
  NewKeyB : array [0..15] of byte;

begin
  // obsuga mieszania z danymi losowymi

  n:=0;
  while (n<32) do                                                               // przejrzenie wszystkich kolejek pod kontem iloci zdarze w kolejce
    begin
      if (RandRandCnt[n]>cardinal(1 shl n)) then                                // sprawdzenie czy wystarczajco duzo zdarze
        begin                                                                   //	jesli do zdarze to wymieszanie zdarze z kluczem generacji
        // przekopiowanie aktualnych zdarze i wyczyszczenie kolejki
          i:=0;
          while (i<8) do
            begin
              NewKeyA[i]:=RandRand[i+(n*16)];
              NewKeyB[i]:=RandRand[i+8+(n*16)];
              NewKeyA[i+8]:=0;
              NewKeyB[i+8]:=0;
              RandRand[i+(n*16)]:=0;
              RandRand[i+8+(n*16)]:=0;
              inc(i);
            end;

          // wygenerowanie nowego klucza
          rijndaelEncrypt(RandKeyA,NewKeyA);
          rijndaelEncrypt(RandKeyB,NewKeyB);

          // zapisanie nowych kluczy generacji i wyczyszczenie buforw pomocniczych
          i:=0;
          while (i<16) do
            begin
              RandKeyA[i]:=NewKeyA[i];
              RandKeyB[i]:=NewKeyB[i];
              NewKeyA[i]:=0;
              NewKeyB[i]:=0;
              inc(i);
            end;
        end;
      inc(n);
    end;

  // przekopiowanie aktualnego stanu licznika
  n:=0;
  while (n<16) do
    begin
      Rand[n+Offset]:=RandCnt[n];
      inc(n);
    end;

  // zwikszenie licznika
  inc(RandCnt[0]);                                                              // zwikszenie najmlodszego bajtu
  n:=1;
  while(n<16) do                                                                // sprawdzenie przeniesienia na starszy bajt
    begin
      if (RandCnt[n-1]<>0) then                                                 // sprawdzenie czy modszy bajt wyzerowany
        inc(RandCnt[n])                                                         //	wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
      else
        break;										                                              // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
      inc(n);
    end;

  // wygenerowanei wartoci wyjciowej (pseudolosowej)
  rijndaelEncrypt(RandKeyA,Rand);
  rijndaelEncrypt(RandKeyB,Rand);

  // wygenerowanie nowego pierwszego klucza

  // przekopiowanie aktualnego stanu licznika
  n:=0;
  while (n<16) do
    begin
      NewKeyA[n]:=RandCnt[n];
      inc(n);
    end;

  // zwikszenie licznika
  inc(RandCnt[0]);                                                              // zwikszenie najmlodszego bajtu
  n:=1;
  while(n<16) do                                                                // sprawdzenie przeniesienia na starszy bajt
    begin
      if (RandCnt[n-1]<>0) then                                                 // sprawdzenie czy modszy bajt wyzerowany
        inc(RandCnt[n])                                                         //	wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
      else
        break;                                                                  // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
      inc(n);
    end;

  // wygenerowanie nowego klucza
  rijndaelEncrypt(RandKeyA,NewKeyA);
  rijndaelEncrypt(RandKeyB,NewKeyA);

  // wygenerowanie nowego drugiego klucza

  // przekopiowanie aktualnego stanu licznika
  n:=0;
  while (n<16) do
    begin
      NewKeyB[n]:=RandCnt[n];
      inc(n);
    end;

  // zwikszenie licznika
  inc(RandCnt[0]);                                                              // zwikszenie najmlodszego bajtu
  n:=1;
  while(n<16) do                                                                // sprawdzenie przeniesienia na starszy bajt
    begin
      if (RandCnt[n-1]<>0)	then                                                // sprawdzenie czy modszy bajt wyzerowany
        inc(RandCnt[n])                                                         //	wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
      else
        break;                                                                  // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
      inc(n);
    end;

  // wygenerowanie nowego klucza
  rijndaelEncrypt(RandKeyA,NewKeyB);
  rijndaelEncrypt(RandKeyB,NewKeyB);

  // zapamitanie nowych kluczy i wyczyszczenie buforw pomocniczych
  n:=0;
  while (n<16) do
    begin
      RandKeyA[n]:=NewKeyA[n];
      RandKeyB[n]:=NewKeyB[n];
      NewKeyA[n]:=0;
      NewKeyB[n]:=0;
      inc(n);
    end;
end;

{*****************************************************************************
Funkcja inicjuje generator liczb pseudolosowych
We:
	Adres na blok danych inicjujcych

*****************************************************************************}

procedure TVTT_RandInit(var Init : array of byte);
var n, m : cardinal;
    TmpTbl: array [0..15] of Byte;
begin

  // rozszyfrowanie tablic
  n:=1;
  while(n<4) do
    begin
      for m := 0 to 15 do TmpTbl[m] := Init[n*16+m];
      rijndaelDecrypt(Init, TmpTbl);
      for m := 0 to 15 do Init[n*16+m] := TmpTbl[m];
      inc(n);
    end;

  // usunicie mieszania tablic
  n:=16;
  while(n<(16*4)) do
    begin
      Init[n]:=Init[n] xor n;
      inc(n);
    end;

  // przepisanie danych z bloku do tablic
  n:=0;
  while (n<16) do
    begin
      RandKeyA[n]:=Init[n+16];
      RandKeyB[n]:=Init[n+32];
      RandCnt[n]:=Init[n+48];
      inc(n);
    end;
end;

{*****************************************************************************
Funkcja zwraca blok danych do uycia przy nastpnej inicjalizacji generatora
	liczb pseudolosowych
We:
	Adres na blok do ktrego zapis danych opisujcych stan generatora
Wy:
	Blok danych opisujcych stan generatora

*****************************************************************************}

procedure TVTT_RandGetInit(var Init : array of byte);
var TmpTbl: array [0..15] of Byte;
    i: Integer;
begin
  TVTT_Rand(Init);
  for i := 0 to 15 do TmpTbl[i] := Init[16+i];
  TVTT_Rand(TmpTbl);
  for i := 0 to 15 do Init[16+i] := TmpTbl[i];
  for i := 0 to 15 do TmpTbl[i] := Init[32+i];
  TVTT_Rand(TmpTbl);
  for i := 0 to 15 do Init[32+i] := TmpTbl[i];
  for i := 0 to 15 do TmpTbl[i] := Init[48+i];
  TVTT_Rand(TmpTbl);
  for i := 0 to 15 do Init[48+i] := TmpTbl[i];
end;
end.
