unit ZeroMem;


interface
uses SysUtils;

type
  PByte = ^Byte;

{$UNSAFECODE ON}
  procedure CopyMemory(dest, src: PByte; len: Integer); unsafe;
  procedure StrCopy(dest: PAnsiChar; src: String); unsafe;
{$UNSAFECODE OFF}
  procedure CopyTable(var Dest, Src: array of Byte;
                      OffsetDest, OffsetSrc, Count: Integer);
  procedure ZeroMemory(var tData: array of Byte; Count: Integer;
                       Offset: Integer = 0);
  procedure Print16(Data  : array of byte);
implementation
//------------------------------------------------------------------------------
procedure CopyMemory(dest, src: PByte; len: Integer);
begin
  while len > 0 do
  begin
    dest^ := src^;
    inc(dest);
    inc(src);
    dec(len);
  end;
end;
//------------------------------------------------------------------------------
procedure StrCopy(dest: PAnsiChar; src: String);
var i: Integer;
begin
  for i := 1 to Length(src) do
  begin
    dest^ := AnsiChar(src[i]);
    dest := dest + 1;
  end;
  dest^ := #0;
end;
//------------------------------------------------------------------------------
procedure CopyTable(var Dest, Src: array of Byte;
                    OffsetDest, OffsetSrc, Count: Integer);
begin
  repeat
    Dec(Count);
    dest[Count+OffsetDest] := src[Count+OffsetSrc];
  until Count = 0;
end;
//------------------------------------------------------------------------------
procedure ZeroMemory(var tData: array of Byte; Count: Integer;
                     Offset: Integer = 0);
begin
  Dec(Count);
  while Count>=0 do
  begin
    tData[Count+Offset]:=0;
    Dec(Count);
  end;
end;
//------------------------------------------------------------------------------
procedure Print16(Data  : array of byte);
var
	n : byte;
begin
  n:=0;
  while (n<16) do
    begin
      if (n<15) then
        write(IntToHex(Data[n],2) + ' ')
      else
        write(IntToHex(Data[n],2));
      inc(n);
    end;
  writeln('');
end;
end.

